# coding: utf-8
"""
    Cortex Inference API.

    OpenAPI 3.0 specification for the Cortex REST API  # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech

    Do not edit this file manually.
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Union

from pydantic import BaseModel, ConfigDict, StrictStr

from typing import Any, ClassVar, Dict, List, Optional


class StreamingCompleteResponseDataEventChoicesInnerDelta(BaseModel):
    """A model object representing the StreamingCompleteResponseDataEventChoicesInnerDelta resource.

    Constructs an object of type StreamingCompleteResponseDataEventChoicesInnerDelta with the provided properties.

    Parameters
    __________
    content : str, optional
        Change in text-completion response content since previous event.
    """

    content: Optional[StrictStr] = None

    __properties = ["content"]

    class Config:
        populate_by_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias."""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias."""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(
            cls, json_str: str
    ) -> StreamingCompleteResponseDataEventChoicesInnerDelta:
        """Create an instance of StreamingCompleteResponseDataEventChoicesInnerDelta from a JSON string."""
        return cls.from_dict(json.loads(json_str))

    def to_dict(
        self,
        hide_readonly_properties: bool = False,
    ) -> Dict[str, Any]:
        """Returns the dictionary representation of the model using alias."""

        exclude_properties = set()

        if hide_readonly_properties:
            exclude_properties.update({})

        _dict = dict(
            self._iter(to_dict=True,
                       by_alias=True,
                       exclude=exclude_properties,
                       exclude_none=True))

        return _dict

    def to_dict_without_readonly_properties(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model without readonly properties."""
        return self.to_dict(hide_readonly_properties=True)

    @classmethod
    def from_dict(
            cls,
            obj: dict) -> StreamingCompleteResponseDataEventChoicesInnerDelta:
        """Create an instance of StreamingCompleteResponseDataEventChoicesInnerDelta from a dict."""

        if obj is None:
            return None

        if type(obj) is not dict:
            return StreamingCompleteResponseDataEventChoicesInnerDelta.parse_obj(
                obj)

        _obj = StreamingCompleteResponseDataEventChoicesInnerDelta.parse_obj({
            "content":
            obj.get("content"),
        })

        return _obj


from typing import Optional, List, Dict


class StreamingCompleteResponseDataEventChoicesInnerDeltaModel():

    def __init__(
        self,  # optional properties
        content: Optional[str] = None,
    ):
        """A model object representing the StreamingCompleteResponseDataEventChoicesInnerDelta resource.

        Constructs an object of type StreamingCompleteResponseDataEventChoicesInnerDelta with the provided properties.

        Parameters
        __________
        content : str, optional
            Change in text-completion response content since previous event.
        """

        self.content = content

    __properties = ["content"]

    def _to_model(self):
        return StreamingCompleteResponseDataEventChoicesInnerDelta(
            content=self.content, )

    @classmethod
    def _from_model(
            cls,
            model) -> StreamingCompleteResponseDataEventChoicesInnerDeltaModel:
        return StreamingCompleteResponseDataEventChoicesInnerDeltaModel(
            content=model.content, )

    def to_dict(self):
        """Creates a dictionary of the properties from a StreamingCompleteResponseDataEventChoicesInnerDelta.

        This method constructs a dictionary with the key-value entries corresponding to the properties of the StreamingCompleteResponseDataEventChoicesInnerDelta object.

        Returns
        _______
        dict
            A dictionary object created using the input model.
        """
        return self._to_model().to_dict()

    @classmethod
    def from_dict(
            cls, obj: dict
    ) -> StreamingCompleteResponseDataEventChoicesInnerDeltaModel:
        """Creates an instance of StreamingCompleteResponseDataEventChoicesInnerDelta from a dict.

        This method constructs a StreamingCompleteResponseDataEventChoicesInnerDelta object from a dictionary with the key-value pairs of its properties.

        Parameters
        ----------
        obj : dict
            A dictionary whose keys and values correspond to the properties of the resource object.

        Returns
        _______
        StreamingCompleteResponseDataEventChoicesInnerDelta
            A StreamingCompleteResponseDataEventChoicesInnerDelta object created using the input dictionary; this will fail if the required properties are missing.
        """
        return cls._from_model(
            StreamingCompleteResponseDataEventChoicesInnerDelta.from_dict(obj))


StreamingCompleteResponseDataEventChoicesInnerDelta._model_class = StreamingCompleteResponseDataEventChoicesInnerDeltaModel
